/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.fel.pjv.cv4;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author martin
 */
public class CarGener implements BicycleVisitable{
    
   private CarColor cc;

    public CarGener() {
        
        this.cc = CarColor.WHITE;
    }
    
   ArrayList<AnyHolder<Bicycle>> carHolders = new ArrayList<AnyHolder<Bicycle>>(4);
        
   @Override
   public void accept(Bicycle b){
       addHolder(new AnyHolder<Bicycle>(b));
   }
   
   @Override
   public void accept(MountainBike b){
       addHolder(new AnyHolder<MountainBike>(b));
   }
   
   @Override
   public void accept(RoadBike b){
       addHolder(new AnyHolder<RoadBike>(b));
   }
   
   private void addHolder(AnyHolder bh){
       if (carHolders.size()<4){
            carHolders.add(bh);
       }
   }
   

   public void printBikes(){
       for (AnyHolder<Bicycle> carHolder : carHolders) {
           System.out.println("Holder: " +carHolder.getClass().getName()+" is holding:");
           carHolder.getItem().printDescription();
           System.out.println("Barva auta: "+cc.getColorCode()+" kod barvy: "+cc.getColorName());
           System.out.println("");
       }
   }
   
    
}
